image: "python:3.7"

variables:
  test_serv:
  prod_serv:
  build_name: "${CI_PROJECT_NAME}_${CI_COMMIT_REF_NAME}-tag_${CI_COMMIT_TAG}-${CI_COMMIT_SHORT_SHA}"


cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - .pip

.make_python_env: &make_python_env
  - python --version
  - mkdir -p .pip
  - pip install -U pip
  - pip --cache-dir=.pip install -r lint_requirements.txt

.prepare_ssh: &prepare_ssh
    - apt-get update -qq
    - apt-get install -qq git
    - 'which ssh-agent || ( apt-get install -qq openssh-client )'
    - eval $(ssh-agent -s)
    - ssh-add <(echo "$SSH_PRIVATE_KEY")
    - mkdir -p ~/.ssh

.prepare_build: &prepare_build
  - rm -rf .git .pip .flake8 .pylintrc .gitignore .gitlab-ci.yml pre-commit-hook.sh

stages:
  - Static Analysis
  - Test
  - Build
  - Prepare ssh
  - Deploy

flake8:
  stage: Static Analysis
  before_script:
    - *make_python_env
  script:
    - flake8 .

pytest:
  stage: Test
  before_script:
    - *make_python_env
  script:
  - pytest .

build:
  stage: Build
  script:
    - *prepare_build

  artifacts:
    name: $build_name
    when: on_success
    paths:
      - ./*

.deploy:
  dependencies:
    - build
  stage: Deploy
  when: manual
  allow_failure: false
  before_script:
    - *prepare_ssh
    - *prepare_build
  script:
    - ssh -tt root@$host "rm -rf /tmp/fake_bank"; # just for example
    - scp -rp $CI_PROJECT_DIR root@$host:/tmp/fake_bank;  # just for example
    - ssh -tt root@$host "/tmp/fake_bank/devops/deploy.sh" # just for example


deploy_to_test:
  variables:
    host: $test_serv
  extends:
    - .deploy

deploy_to_prod:
  variables:
    host: $prod_serv
  extends:
    - .deploy
